Django/Blog_Project/Application/Application/urls.py
from unicodedata import name
from django.contrib import admin
from django.urls import path, include
from accounts import views as account_views
from django.contrib.auth import views as auth_views

from django.conf import settings
from django.conf.urls.static import static


urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('blog.urls')),
    #path('account/', include('accounts.urls')),
    path('register/', account_views.register, name='register'),
    path('profile/', account_views.profile, name='profile'),
    path('login/', auth_views.LoginView.as_view(template_name = 'accounts/login.html'), name='login'),
    path('logout/', auth_views.LogoutView.as_view(template_name = 'accounts/logout.html'), name='logout'),
]

if settings.DEBUG:
    urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

Django/Blog_Project/Application/blog/urls.py
from unicodedata import name
from django.urls import path
from .import views
from .views import PostView, PostDetail, PostCreate, PostUpdate, PostDelete, CommentView
from django.conf import settings
from django.conf.urls.static import static

urlpatterns = [
    #path('', views.index, name='blog-home'),
    path('', PostView.as_view(), name='blog-home'),

    path('<int:pk>/comment/', CommentView.as_view(), name='blog_comment'),



    
    
    path('post/<pk>/', PostDetail.as_view(), name='post-detail'),
    path('create/', PostCreate.as_view(), name='post-create'),
    path('post/<pk>/update/', PostUpdate.as_view(), name='post-update'),
    path('post/<pk>/delete/', PostDelete.as_view(), name='post-delete'),

    
]


if settings.DEBUG:
    urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

Django/Blog_Project/Application/blog/models.py
from tkinter import CASCADE
from typing import cast
from django.db import models
from django.utils import timezone
from django.contrib.auth.models import User
from django.urls import reverse

# Create your models here.

class Post(models.Model):
    title = models.CharField(max_length=100)
    content = models.TextField()
    date_posted = models.DateTimeField(default=timezone.now)
    author = models.ForeignKey(User, on_delete=models.CASCADE)
    image = models.ImageField(default='default.jpg', upload_to='posts')


    def __str__(self):
        return self.title

    def get_absolute_url(self):
        return reverse('post-detail', kwargs={'pk': self.pk})

    

class Comment(models.Model):
    cmt_post = models.ForeignKey(Post, on_delete=models.CASCADE)
    cmt_user = models.ForeignKey(User, on_delete=models.CASCADE)
    comment = models.TextField(max_length=5000)

    # def get_absolute_url(self):
    #     return reverse('blog-detail', kwargs={'pk': self.pk})
    

Django/Blog_Project/Application/blog/forms.py
from django import forms
from .models import Comment


class CommentFrom(forms.ModelForm):
    class Meta:
        model = Comment
        fields = ['comment']

Django/Blog_Project/Application/blog/views.py
from django.shortcuts import render
from django.http import HttpResponse ,JsonResponse
from .models import Post, Comment

from django.views.generic import ListView, DetailView,CreateView, UpdateView, DeleteView, View

from django.contrib.auth.mixins import LoginRequiredMixin, UserPassesTestMixin
#from .models import Comment

from .forms import CommentFrom

# Create your views here.

class PostView(ListView):
    model = Post
    template_name = 'index.html'
    context_object_name = 'articles'
    ordering = ['-date_posted']

class PostDetail(DetailView):
    model = Post
    template_name = 'detail.html'


   
###########

class PostCreate(LoginRequiredMixin, CreateView):
    model = Post
    template_name = 'create.html'
    ## success_url = 'index'

    fields = ['title', 'content', 'image']

    def form_valid(self, form):
        form.instance.author = self.request.user
        return super().form_valid(form)

class PostUpdate(LoginRequiredMixin, UserPassesTestMixin, UpdateView):
    model = Post
    template_name = 'create.html'
    ## success_url = 'index'

    fields = ['title', 'content', 'image']

    def form_valid(self, form):
        form.instance.author = self.request.user
        return super().form_valid(form)

    def test_func(self):
        post = self.get_object()
        if self.request.user == post.author:
            return True
        else:
            return False

class PostDelete(LoginRequiredMixin, UserPassesTestMixin, DeleteView):
    model = Post
    template_name = 'delete.html'
    success_url = '/'

    def test_func(self):
        post = self.get_object()
        if self.request.user == post.author:
            return True
        else:
            return False




# def index(request):
#     #return HttpResponse("Hello World!!")
#     context = {
#         'articles': Post.objects.all(),
#         # 'comment': Comment.objects.all()
#     }

#     return render(request, 'index.html', context)


class CommentView(LoginRequiredMixin, View):

    def post(self, request, *args, **kwargs): 
        try:
            form = CommentFrom(request.POST)
            print(form.is_valid())
            if form.is_valid():
                p = Post.objects.get(id = self.kwargs.get('pk')) 
                comment = Comment.objects.create(cmt_post=p, cmt_user=request.user, comment=form.cleaned_data['comment'])
                print(comment) 
                instance_obj = {
                    'user': request.user.username, 
                    'comment': form.cleaned_data['comment'],
                }
                print(instance_obj)
                return JsonResponse({'status': 200, 'instance': instance_obj})
            else:
                errors = [(index, value[0]) for index,value in form.errors.items()]
                print(errors)
                return JsonResponse({'status': 400, 'errors': errors})

        except Post.DoesNotExist as e:
            print(e)

Django/Blog_Project/Application/blog/templates/base.html
{% load static %}
<!DOCTYPE html>
<html>
<head>

    <!-- Required meta tags -->
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

    <!-- Bootstrap CSS -->
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/css/bootstrap.min.css" integrity="sha384-Gn5384xqQ1aoWXA+058RXPxPg6fy4IWvTNh0E263XmFcJlSAwiGgFAW/dAiS6JXm" crossorigin="anonymous">

    <link rel="stylesheet" type="text/css" href="{% static 'main.css' %}">


    <script src="https://code.jquery.com/jquery-3.6.0.min.js" integrity="sha256-/xUj+3OJU5yExlq6GSYGSHk7tPXikynS7ogEvDej/m4=" crossorigin="anonymous"></script>


    {% if title %}
        <title>My Blog - {{ title }}</title>
    {% else %}
        <title>My Blog</title>
    {% endif %}
    
</head>
<body>
    <header class="site-header">
      <nav class="navbar navbar-expand-md navbar-dark bg-steel fixed-top">
        <div class="container">
          <a class="navbar-brand mr-4" href="#">My Blog</a>
          <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarToggle" aria-controls="navbarToggle" aria-expanded="false" aria-label="Toggle navigation">
          <span class="navbar-toggler-icon"></span>
          </button>
          <div class="collapse navbar-collapse" id="navbarToggle">
            <div class="navbar-nav mr-auto">
              <a class="nav-item nav-link" href="{% url 'blog-home' %}">Home</a>
            </div>
            <!-- Navbar Right Side -->
            <div class="navbar-nav">
              {% if user.is_authenticated %}
              <a class="nav-item nav-link" href="{% url 'post-create' %}">Create Blog</a>
              <a class="nav-item nav-link" href="{% url 'profile' %}">Profile</a>
              <a class="nav-item nav-link" href="{% url 'logout' %}">Logout</a>
              {% else %}
                <a class="nav-item nav-link" href="{% url 'login' %}">Login</a>
                <a class="nav-item nav-link" href="{% url 'register' %}">Register</a>
            </div>
            {% endif %}
          </div>
        </div>
      </nav>
    </header>
    <main role="main" class="container">
      <div class="row">
        <div class="col-md-8 blog">
          <!-- {% if messages %}
            {% for message in messages %}
              <div class="alert alert-success">
                  {{message}}
              </div>

            {% endfor %}

          {% endif %} -->
          {% block content %}{% endblock %}
        </div>

      </div>
    </main>

    <!-- Optional JavaScript -->
    <!-- jQuery first, then Popper.js, then Bootstrap JS -->
    <!-- <script src="https://code.jquery.com/jquery-3.2.1.slim.min.js" integrity="sha384-KJ3o2DKtIkvYIK3UENzmM7KCkRr/rE9/Qpg6aAZGJwFDMVNA/GpGFF93hXpG5KkN" crossorigin="anonymous"></script> -->
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.12.9/umd/popper.min.js" integrity="sha384-ApNbgh9B+Y1QKtv3Rn7W3mgPxhU9K/ScQsAP7hUibX39j7fakFPskvXusvfa0b4Q" crossorigin="anonymous"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/js/bootstrap.min.js" integrity="sha384-JZR6Spejh4U02d8jOt6vLEHfe/JQGiRRSQQxSfFWpi1MquVdAyjUar5+76PVCmYl" crossorigin="anonymous"></script>
</body>
</html>

Django/Blog_Project/Application/blog/templates/comment.html
{% extends 'base.html' %}
{% load crispy_forms_tags %}

{% block content %}

<div class="content-section">
    <form method="POST" enctype="multipart/form-data">
        {% csrf_token %}
        <fieldset class="form-group">
            <legend class="border-bottom mb-4">Create Blog</legend>
            {{comments.cmt_post}}
            {{comments.cmt_user}}
            {{comments.comment}}
        </fieldset>
        <div class="form-group">
            <button class="btn btn-outline-primary" type="submit">Comment</button>
        </div>
    </form>
    
</div>
{% endblock %}

Django/Blog_Project/Application/blog/templates/create.html
{% extends 'base.html' %}
{% load crispy_forms_tags %}

{% block content %}

<div class="content-section">
    <form method="POST" enctype="multipart/form-data">
        {% csrf_token %}
        <fieldset class="form-group">
            <legend class="border-bottom mb-4">Create Blog</legend>
            {{ form|crispy }}
        </fieldset>
        <div class="form-group">
            <button class="btn btn-outline-primary" type="submit">Add</button>
        </div>
    </form>
    <div class="border-top pt-3">
        
    </div>
</div>
{% endblock %}

Django/Blog_Project/Application/blog/templates/delete.html
{% extends 'base.html' %}

{% block content %}

<div class="content-section">
    <form method="POST" enctype="multipart/form-data">
        {% csrf_token %}
        <fieldset class="form-group">
            <legend class="border-bottom mb-4">Delete Blog</legend>
            <h2>You want to delete "{{object.title}}"</h2>
        </fieldset>
        <div class="form-group">
            <button class="btn btn-outline-danger" type="submit">Delete</button>
            <a class="btn btn-outline-secondary" href="{% url 'post-detail' object.id %}">Cancel</a>

        </div>
    </form>
    <div class="border-top pt-3">
        
    </div>
</div>
{% endblock %}

Django/Blog_Project/Application/blog/templates/detail.html
{% extends "base.html" %}
{% block content %}
        <article class="media content-section">
          <img class="rounded-circle article-img" src="{{ object.author.profile.image.url }}">
          <div class="media-body">
            <div class="article-metadata">
              <a class="mr-2" href="#">{{ object.author }}</a>
              <small class="text-muted">{{ object.date_posted|date:"F d, Y, P"}}</small>
              {% if object.author == user %}
                <a href="{% url 'post-update' object.id %}" class="btn btn-primary btn-sm mt-1 mb-1">Update</a>
                <a href="{% url 'post-delete' object.id %}" class="btn btn-danger btn-sm mt-1 mb-1">Delete</a>

            {% endif %}
            </div>
            <h2 class="article-title">{{object.title}}</h2>
            <p class="article-content">{{ object.content }}</p>
            <hr>
            <img class="account-img1" src="{{ object.image.url }}">
            <br><br>
          
            {% if user.is_authenticated %}


            <h3>Comment Here</h3>
            <form method="POST" id="comment-form" novalidate>
              {% csrf_token %}
              <div class="input-group mb-3">
                <input type="text" class="form-control col-lg-9" placeholder="" aria-label="" aria-describedby="basic-addon1" name="comment" required>
              <div class="input-group-prepend">
                <input type="submit" value="Comment" class="btn btn-success mb-0.9">
                </div>
              </div>
              <h4><u>List of Comments</u></h4>
            </form>
            
            
            {% for c in object.comment_set.all %}
            
            <hr>
             <b>{{c.cmt_user}}:</b> 
              {{c.comment}}
              <hr>
            {% endfor %}

            {% else %}
            <div class="input-group mb-3">
              <input type="text" class="form-control col-lg-9" required>
            <div class="input-group-prepend">
              <a href="{% url 'register' %}"><input type="submit" value="Comment" class="btn btn-success mb-0.9"></a>
              </div>
            </div>
              <h4>Register and Login to comment</h4>

              {% for c in object.comment_set.all %}
            
            <hr>
             <b>{{c.cmt_user}}:</b> 
              {{c.comment}}
              <hr>
            {% endfor %}

            {% endif %}





            

            


          </div>
        </article>


        <script>

      $('#comment-form').on('submit', function(e){
            e.preventDefault();
            let formData = new FormData(this);  
            const postId = "{{object.id}}";
            const commentUrl = "{% url 'blog_comment' 11 %}".replace(11, postId );

            for(let v of formData.entries()){
                console.log(v[0], v[1])
            }

            $.ajax({
                url: commentUrl,
                method:'POST',
                data: formData,
                processData:false,
                contentType: false,
                
                success: function(resp){
                    $('#comment-form')[0].reset();
                    console.log(resp);
                    if(resp.status == 200){
                        let instance = resp.instance;
                        console.log(instance)
                        let r = `<p><b>${instance.user}</b><br>${instance.comment}</p>`;
                        $('#comment-form').append(r);
                    }else{
                        alert(resp.errors[0][1]);
                    }
                },
                error: function(err){
                    console.log(err);
                }
            })
         })


        </script>
{% endblock content %}

Django/Blog_Project/Application/blog/templates/index.html
{% extends "base.html" %}
{% block content %}
    {% for article in articles %}
        <article class="media content-section">
          <img class="rounded-circle article-img" src="{{ article.author.profile.image.url }}">
          <div class="media-body">
            <div class="article-metadata">
              <a class="mr-2" href="#">{{ article.author }}</a>
              <small class="text-muted">{{ article.date_posted|date:"F d, Y, P"}}</small>
            </div>
            <h2><a class="article-title" href="{% url 'post-detail' article.id %}">{{ article.title }}</a></h2>
            <p class="article-content">{{ article.content }}</p>
            <hr>
            <img class="account-img1" src="{{ article.image.url }}">
            <br><br>
            </div>
        </article>
    {% endfor %}

    <!-- {% for cmt in comment %}
        {{ cmt.cmt_post }} <br>
        {{ cmt.cmt_user }}
        {{ cmt.comment }}
    {% endfor %} -->
{% endblock content %}